/* ConflictDialog.c generated by valac 0.38.10, the Vala compiler
 * generated from ConflictDialog.vala, do not modify */

/*
* Copyright (c) 2017-2018 elementary, LLC. (https://elementary.io)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include <glib.h>
#include <glib-object.h>
#include <granite.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <glib/gi18n-lib.h>
#include <gtk/gtk.h>


#define TYPE_CONFLICT_DIALOG (conflict_dialog_get_type ())
#define CONFLICT_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CONFLICT_DIALOG, ConflictDialog))
#define CONFLICT_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CONFLICT_DIALOG, ConflictDialogClass))
#define IS_CONFLICT_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CONFLICT_DIALOG))
#define IS_CONFLICT_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CONFLICT_DIALOG))
#define CONFLICT_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CONFLICT_DIALOG, ConflictDialogClass))

typedef struct _ConflictDialog ConflictDialog;
typedef struct _ConflictDialogClass ConflictDialogClass;
typedef struct _ConflictDialogPrivate ConflictDialogPrivate;
enum  {
	CONFLICT_DIALOG_0_PROPERTY,
	CONFLICT_DIALOG_NUM_PROPERTIES
};
static GParamSpec* conflict_dialog_properties[CONFLICT_DIALOG_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
enum  {
	CONFLICT_DIALOG_REASSIGN_SIGNAL,
	CONFLICT_DIALOG_NUM_SIGNALS
};
static guint conflict_dialog_signals[CONFLICT_DIALOG_NUM_SIGNALS] = {0};

struct _ConflictDialog {
	GraniteMessageDialog parent_instance;
	ConflictDialogPrivate * priv;
};

struct _ConflictDialogClass {
	GraniteMessageDialogClass parent_class;
};


static gpointer conflict_dialog_parent_class = NULL;

GType conflict_dialog_get_type (void) G_GNUC_CONST;
ConflictDialog* conflict_dialog_new (const gchar* shortcut, const gchar* conflict_action, const gchar* this_action);
ConflictDialog* conflict_dialog_construct (GType object_type, const gchar* shortcut, const gchar* conflict_action, const gchar* this_action);
static GObject * conflict_dialog_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
static void _conflict_dialog___lambda36_ (ConflictDialog* self, gint response_id);
static void __conflict_dialog___lambda36__gtk_dialog_response (GtkDialog* _sender, gint response_id, gpointer self);


ConflictDialog* conflict_dialog_construct (GType object_type, const gchar* shortcut, const gchar* conflict_action, const gchar* this_action) {
	ConflictDialog * self = NULL;
	GThemedIcon* _tmp0_;
	GThemedIcon* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	g_return_val_if_fail (shortcut != NULL, NULL);
	g_return_val_if_fail (conflict_action != NULL, NULL);
	g_return_val_if_fail (this_action != NULL, NULL);
	_tmp0_ = (GThemedIcon*) g_themed_icon_new ("dialog-warning");
	_tmp1_ = _tmp0_;
	_tmp2_ = shortcut;
	_tmp3_ = conflict_action;
	_tmp4_ = g_strdup_printf (_ ("%s is already used for %s"), _tmp2_, _tmp3_);
	_tmp5_ = _tmp4_;
	_tmp6_ = this_action;
	_tmp7_ = conflict_action;
	_tmp8_ = g_strdup_printf (_ ("If you reassign the shortcut to %s, %s will be disabled."), _tmp6_, _tmp7_);
	_tmp9_ = _tmp8_;
	self = (ConflictDialog*) g_object_new (object_type, "image-icon", _tmp1_, "primary-text", _tmp5_, "secondary-text", _tmp9_, NULL);
	_g_free0 (_tmp9_);
	_g_free0 (_tmp5_);
	_g_object_unref0 (_tmp1_);
	return self;
}


ConflictDialog* conflict_dialog_new (const gchar* shortcut, const gchar* conflict_action, const gchar* this_action) {
	return conflict_dialog_construct (TYPE_CONFLICT_DIALOG, shortcut, conflict_action, this_action);
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static void _conflict_dialog___lambda36_ (ConflictDialog* self, gint response_id) {
	gint _tmp0_;
	_tmp0_ = response_id;
	if (_tmp0_ == 1) {
		g_signal_emit (self, conflict_dialog_signals[CONFLICT_DIALOG_REASSIGN_SIGNAL], 0);
	}
	gtk_widget_destroy ((GtkWidget*) self);
}


static void __conflict_dialog___lambda36__gtk_dialog_response (GtkDialog* _sender, gint response_id, gpointer self) {
	_conflict_dialog___lambda36_ ((ConflictDialog*) self, response_id);
}


static GObject * conflict_dialog_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	GObjectClass * parent_class;
	ConflictDialog * self;
	GtkWidget* reassign_button = NULL;
	GtkWidget* _tmp0_;
	GtkWidget* _tmp1_;
	GtkWidget* _tmp2_;
	GtkStyleContext* _tmp3_;
	parent_class = G_OBJECT_CLASS (conflict_dialog_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_CONFLICT_DIALOG, ConflictDialog);
	gtk_window_set_deletable ((GtkWindow*) self, FALSE);
	gtk_window_set_modal ((GtkWindow*) self, TRUE);
	gtk_window_set_resizable ((GtkWindow*) self, FALSE);
	gtk_dialog_add_button ((GtkDialog*) self, _ ("Cancel"), 0);
	_tmp0_ = gtk_dialog_add_button ((GtkDialog*) self, _ ("Reassign"), 1);
	_tmp1_ = _g_object_ref0 (_tmp0_);
	reassign_button = _tmp1_;
	_tmp2_ = reassign_button;
	_tmp3_ = gtk_widget_get_style_context (_tmp2_);
	gtk_style_context_add_class (_tmp3_, GTK_STYLE_CLASS_DESTRUCTIVE_ACTION);
	g_signal_connect_object ((GtkDialog*) self, "response", (GCallback) __conflict_dialog___lambda36__gtk_dialog_response, self, 0);
	_g_object_unref0 (reassign_button);
	return obj;
}


static void conflict_dialog_class_init (ConflictDialogClass * klass) {
	conflict_dialog_parent_class = g_type_class_peek_parent (klass);
	G_OBJECT_CLASS (klass)->constructor = conflict_dialog_constructor;
	conflict_dialog_signals[CONFLICT_DIALOG_REASSIGN_SIGNAL] = g_signal_new ("reassign", TYPE_CONFLICT_DIALOG, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}


static void conflict_dialog_instance_init (ConflictDialog * self) {
}


GType conflict_dialog_get_type (void) {
	static volatile gsize conflict_dialog_type_id__volatile = 0;
	if (g_once_init_enter (&conflict_dialog_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ConflictDialogClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) conflict_dialog_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ConflictDialog), 0, (GInstanceInitFunc) conflict_dialog_instance_init, NULL };
		GType conflict_dialog_type_id;
		conflict_dialog_type_id = g_type_register_static (GRANITE_TYPE_MESSAGE_DIALOG, "ConflictDialog", &g_define_type_info, 0);
		g_once_init_leave (&conflict_dialog_type_id__volatile, conflict_dialog_type_id);
	}
	return conflict_dialog_type_id__volatile;
}



